Overview

 Top Next

Process Tamer

v2.11.01, April 23rd, 2009

Windows 2k/XP/Vista

Process Tamer is a tiny (140k) and efficient utility for Microsoft Windows XP/2K/NT that runs in your system tray and constantly monitors the cpu usage of other processes. When it sees a process that is overloading your cpu, it reduces the priority of that process temporarily, until its cpu usage returns to a reasonable level.

There are many times when a process will hog your cpu, such as when converting audio/video files, or working with compressed archives. Because these processes completely consume the cpu, your system becomes sluggish to respond and using the computer for other tasks becomes impossible while these processes are running.

Process Tamer solves this problem by identifying such these degenerate conditions and temporarily reducing the priority of the offending processes in order to allow your system to respond to other requests. Stop being a victim to an overloaded cpu - let Process Tamer keep your system responsive no matter what you're doing.


MICROSOFT VISTA USERS - READ IN

 Top Previous Next

MICROSOFT VISTA USERS!

The ProcessTamerTray.exe and ProcesTamerGuiConfigurator.exe processes MUST be run with administrator privileges in order to work.

You can set this by right clicking on the program file and selecting "Run as Administrator", or going to advanced shortcut properties and permanently setting this value.


Using Process Tamer

Process Tamer requires minimal interaction; you simply run it and it sits in your system tray.

By default you'll see a baloon tooltip in your system tray whenever Process Tamer adjusts or restores the priority of an application, so you'll always know what it's doing and why.

The icon glows yellow when a process it being "tamed."

Process Tamer is very configurable - if you prefer, tell Process Tamer to just do its work silently behind the scenes - it's all up to you.


Enabling and Disabling

DISABLE / ENABLE PROCESS TAMER

There are times when you might not want Process Tamer to change priorities, such as when playing games or if you are burning a cd/dvd on a slow computer.

You can easily add special exception rules for certain processes, or if you prefer, you can simply toggle Process Tamer on and off by double clicking on its tray icon (disabling it will automatically restore processes to their original cpu priority).

The icon will change from colored to gray to indicate it is disabled.

Note: You can change the action of the double-click in the configuration dialog.


Configuration

Process Tamer is very configurable:

· You can choose how you get notified and under what circumstances.
· You can choose which processes to ignore or force to certain priorities.
· You can easily enable or disable cpu usage taming and adjust how sensitive it is (or just select defaults which work well).
· You can configure the program to start with windows and/or keep a log file.
· You can customize the double-click action, and configure a helper process explorer program for its tray menu.
· You can set a variety of foreground boost options

You configure ProcessTamer options using a standalone configuration tool.

The configuration tool is a completely separate program from the main ProcessTamer Tray tool (which runs in the background for maximum efficiency), and is run only when you need to configure the memory-resident tray-based tool..

When the configuration dialog is open you can hold your mouse over a setting to get a longer description. If you get lost you can hit the "Set Defaults" button to return all settings to their default value.

In the sub-sections that follow we will discuss all of these options in more details..


System Options

1. Start with Windows - If this is checked then Process Tamer will automatically start up whenever you boot your computer.
2. Log File - If this is checked the Process Tamer keeps a log of all processes it has modified. The log can be viewed simply by switching to the Log tab. Useful for debugging problems.
3. Run High Priority - Tells Process Tamer itself to run at high priority. This can be useful if you occassionally run programs which take complete control over your computer with 100% cpu usage, because it allows Process Tamer to run faster than them.
4. Double-click Tray - Here you can customize what Process Tamer does when you double click on its system tray icon. Typical values are: Toggle Enable, Configure, or Launch 3rd party tool.
5. Optional 3rd Party Tool - Process Tamer has it's own built-in mini task manager, but there are more powerful process manipulation tools you might prefer. Here you can configure any other program you want to be available from the system tray (or optionally launched on double click).
6. Tool Menu Caption - Label to use in the menu for the 3rd Party tool you configure.


Balloon Options

You can decide which actions should generate a system tray balloon messages.

On CPU-based Taming - triggered when Process Tamer reduces priority of a cpu intensive application.

On CPU-based Restoration - triggered when Process Tamer restores the priority of a previously tamed application.

On Explicit Rule Application - triggered when Process Tamer applies one of your explicit override rules to force an application to have a specific priority.

Often when you first install Process Tamer you will enjoy seeing all messages, but as you grow to trust it you may want to disable most of them.

Secret Tip: Having balloon messages enabled on CPU-based Restoration can be nice way of being alerted when a cpu intensive process finishes.


Special Foreground Process Options

Process Tamer has some special things it can do with the program you are currently using at any given moment.

Boost Foreground Process to High Priority - this is a somewhat controversial option which will automatically (temporarily) set the priority of the application you are currently using to high priority. This should not normally be needed, as Microsoft Windows should give the current application plenty of CPU cycles, but it can be useful in odd cases where you want to devote more resources to whatever program you are currently using. The process priority will be restored to normal when you switch to another application. Note: The foreground process (currently active program) can still be tamed when this setting is enabled alone.

Protect Foreground Process from CPU Taming - this is a generally a more useful feature than foreground boosting. It tells Process Tamer that even if the foreground process uses a huge amount of cpu, don't tame it as long as it remains the focused active window. Only when you switch away will it be tamed.

Note: Combining the first two options can lead to unpleasent behavior where a cpu intensive application is raised to high priority when it is the currently active window, worsening the responsiveness of your computer!


CPU Taming Settings

Process Tamer tries to be smart about detecting processes that are using up too much of your computer cpu and are likely to make your pc less responsive, but there is always room for tweaking the settings to your personal tastes.

You can enable or disable Taming based on CPU usage using the group checkbox. You may prefer to only use your explicit rule overrides to manage priorities; if so just uncheck this box.

CPU Usage Trigger Low - Below this average cpu usage, previously tamed processes will be restored to their original priority.

CPU Usage Trigger High - Above this average cpu usage, the priority of a process will reduced to low priority.

Min. Change Interval (s). - Process Tamer will not change the priority of a single program multiple times within this inveral.

CPU Usage Measurement Smoothing Over Time - Process Tamer always looks at "average" cpu usage, smoothed out over a small period of time (seconds), to avoid jumping the gun on processes that only very briefly use a lot of cpu resources (for example at startup). By adjusting this setting you can adjust the smoothing of the average.

TIP: To get a feel for average smoothing, change this setting and go to the Process tab and watch how instantaneous cpu usage of programs matches with their smoothed average cpu usage value.


Explicit Rules

At the bottom of the configuration tab is a list of all explicit rules you have set currently.

You can easily modify them here, or right-click to get a menu to help you add or delete rules.

TIP: You can more easily add rules for running processes from the Mini Task Manager tab.


Using the Mini Task Manager

The Process Tamer Configuration GUI also includes a mini task manager, which you can use to quickly set process priorities manually, add rules, or terminate processes.

The Mini Task Manager shows you running processes, their current cpu usage, their priorities, and any currently set explicit override rules.

Hide < 1% Normal CPU - By default, the Mini Task Manager will hide all processes which are using negligible cpu usage. This option can be very useful to help you identify processes you might be concerned about. If you want to see all processes currently running on your computer uncheck this option.

Remove Old - When you are hiding processes <1% CPU, this option says to slowly remove apps that fall back to low cpu usage after they have jumped above 1%. You would normally leave this checked but you might uncheck it if you want to be able to see all processes which have used more than 1% in some period.

To change the priority of a process instantly just click on its Priority value and set it to what you want. The priority will be changed instantly, and wll persist until the target program exits.

If you want to have the target program priority ALWAYS adjusted every time it runs, set an Explicit Rule by clicking the drop down arrow in that collumn. From there you can also tell Process Tamer to IGNORE the program when it comes to CPU taming, or to immediately terminate the process whenever it is found running.

You can also terminate processes from this screen by right clicking on them and choosing the appropriate pop-up menu item.


Tips, Tricks, and Troubleshooting

Program Doesn't Seem to Work?

If the ProcessTamer GUI Configurator always says the tray tool is not running, and ProcessTamer doesn't seem to be working at all, it may be that you have disabled the Windows Performance Monitor Service, or run a tweaking tool that has done so.

Known programs that may do this: XP Smoker, XPlite

See http://www.donationcoder.com/Forums/bb/index.php?topic=1092.0 for more information.

No Balloon Bubbles in the Tray?

Some people have balloon messages completely disabled on their system.

See http://www.donationcoder.com/Forums/bb/index.php?topic=3836.0 for more information.

See http://support.microsoft.com/default.aspx?scid=kb;en-us;307729 for fix instructions.


Version History and ToDo List

Version History

v2.11.01 - 4/23/09

· Live update of cpu usage is disabled while changing rules -- avoids problem where grid updating disrupts the modification of rules.

v2.10.02 - 3/31/09

· Added support for the ConfigDir.ini file (allows setting custom directories for config files; better Vista and portable use).
· Updated manifests to insist on administrative rights (needed for Vista and later).
· Fixed issues in vista and with large fonts.
· Packaged more recent dcuhelper.exe update helper.
· Changed start-with-windows process to use registry instead of startup group.
· The programmers who designed Vista should be shot -- they have made it virtually impossible for me to make Process Tamer start with windows. Vista insists on blocking it at startup.
· Fixed some hints and tab order in the Configuration dialog.
· Increased size of Min. Change Interval option.
· Fixed bug that was causing the new configuration tool to crash silently.

v2.09.01 - 8/18/07

· Added support for update checking
· Compiled with manifest to force ProcessTamerTray to run with elevated administrator mode on Microsoft VISTA, which is needed in order to reduce process priorities.

v2.08.02 - 10/11/06

· Process view now remembers sorting order.
· Improved killing of resistant apps (again).

v2.07.02 - 10/02/06

· Stopped pointless announcing about increasing it's own priority.
· Added advanced killing for processes that resisted termination in the past.

v2.06.01 - 9/18/06

· Code added to enable Process Tamer to control priorities of stubborn services (for example winlogon.exe, etc).
· Added tips+troubleshooting help page.

v2.05.02 - 5/11/06

· Help file has been brought fully up to date.

v2.05.01 - 5/09/06

· [new feature] you can now independently turn on/off balloon tray message for taming by cpu use, untaming by cpu usage, and priority adjustment by explicit rules
· [new feature] foreground process boosting option.
· [new feature] foreground process protection option.
· [new feature] option to run PT always at high priority (prevents other apps from being evil)
· [minor improvement] option to hide < 1% processes now doesn't hide non-normal priorities
· [cosmetic bugfix] configuration form checkbox was displaying where it should not.

v2.03.01 - 12/22/05

· [new feature] you can now toggle on/off the taming of processes by cpu use (i.e. only use explicit rules if you prefer)

v2.02.01 - 11/25/05 - Maintenance Releast

· [bugfix] rare bug was causing sequence of error message in the GUI configurator tool if left running for long periods.
· [bugfix] apps sending timer broadcasts could confuse process tamer and cause it to start taming apps prematurely.
· [new feature] option to automatically remove processes with <1% usage from task monitor after a small delay.

v2.00.15 - 4/16/05

· removed setting of ForegroundLockTimeout completely and added 2 extra .reg files in an Extras subdirectory, so users can set this value easily themselves if they wish, along with small readme about the issue.

v2.00.14 - 4/15/05

· bugfix: in a previous recent release during testing i set update speed to once per 5 seconds instead of once per second, causing very delayed detection of high cpu usage apps.

v2.00.13 - 4/14/05

· fixed unnesc. setting of ForegroundLockTimeout (see http://www.donationcoder.com/Forums/bb/index.php?topic=109.msg604 ) [thx scott].
· 3rd party tool for right-click/double-click launch can now specify commandline arguments [thx scott].
· improved (though not perfect) display of Process Tamer 2 GUI on 120dpi screens [thx scott+vampiric]

v2.00.10 - 4/05/05

· faster tray icon update on restoring processes.
· slightly more efficient calculation of performance metrics.
· better handling of unusual unnamed processes..

v2.00.08 - 4/04/05

· small change to force handle the situation where tray or config is called without setting its working dir to it home directory, which could cause it to not be able to launch its partner tool.

v2.00.07 - 4/03/05

· manual adding of rule now allows you to just type in exe name instead of having to browse to it.
· better reporting of all processes being tamed in tooltip + about box.
· better keeping track of tamed processes when re-enabling.

v2.00.06 - 4/02/05

· event timer disabled when ProcessTamer is disabled, for optimum efficiency when disabled.
· fixed resource leak found that would cause gradual leaking of resource as tray icon changed (thanks to Jim Altman at Long Run Associates for finding this bug).

v2.00.05 - 4/01/05

· column sorting is case insensitive.
· new process enumeration routines used on win2k platform, fixes task listing and bug where gui didnt know when tray was running, and couldnt send it signals about options changing.
· new log tab.
· faster startup.

v2.00.01 - 3/31/05

· summary of taming now in tray tooltip.
· instant responsiveness from clicking system tray.
· configuration gui.
· mini task manager tool with fast manual priority changing and app termination.
· right click menu with more options, including ability to specify custom 3rd party tool for menu.
· customize double-click action.
· can disable balloon tips.
· optional logging function.
· glowing icon when processes are being tamed.
· added startup-with-windows option.
· about box shows process currently being tamed.
· support for accurate cpu usage metrics on multiprocessor systems (untested)
· restores performance counters on exit.
· new cpu eating test program included.

v1.03.02 - 03/11/05

· You can now specify rules in the file ApplicationOverrides.txt which tell the program to ignore certain processes or force them immediately to a certain priority (or even kill them if found running).
· version information shown in about box.
· efficient custom hash function.

v1.01.01 - 02/27/05

· First release - major functions working.

v1.00.01 - 02/25/05

· Basic tray functionality

ToDo List:

· when messages disabled make sure the try icon still changes,etc.
· firewall type popup on new programs
· multilingual
· show last tames process and time in the tooltip (ie.. last tamed process was wswater.exe, 20 minutes ago)
· "emergency override" hotkey where you could correct the situation where a high priority app is suddenly taking over your cpu, and the idea of maybe having an option that says to not lower priority of apps that are in the foreground (nice idea!). Adding these ideas to todo list for v3. http://www.donationcoder.com/Forums/bb/index.php?topic=1476
· changing dropdown priorities during updating messed up.
· titlebar for windows showing cpu and memory usage (and time)
· separate balloon options for show on explicit, show on increase, show on decrease
· keeps trying to raise priority of apps that wont raise back?
· add affinity system
· add memory tweaker
· add alarms
· add wizard
· add some preset nice profiles
· if app dies while being tamed the app still says tamed
· add program icons to task list
· show memory usage, uptime in gui
· custom rules for apps
· Option to adjust speed of baloons.
· Sometimes get "restoring priority" after app exits.
· Option to disable only "restoring priority" baloon.
· Optional sound on tamiing.
· Clear hint on disable ("restoring priority.." while disabled mesg showing sometimes).
· Add user configurable sounds for taming start+end, and for icons.
· Handle cpuidle and related programs.
· User-configurable timer interval.
· Implement alternate multiprocess cpu usage calculation and taming option
· Win9x support?


Related Programs

 Top Previous

Programs that are similar to Process Tamer:

· http://www.bitsum.com/ProSuper.asp - similar application, works on networked installations (shareware)
· http://www.prioritymaster.com/ - similar program
· http://ivagos.com/index.php?lnk=6 - manually set process priorities (shareware)
· http://www.pgware.com/products/pcboost - boosts priority of currently used app [works on win9X?] (shareware)
· http://threadmaster.tripod.com/ - threadmaster (like cpuidle but free); designed to reduce heat/cpuusage of processes.
· http://www.kwakkelflap.com/watchdog.html - Watchdog-O-Matic (shareware)
· http://www.octopod.org/mambo/index.php?option=com_content&task=view&id=77&Itemid=136 - Process Master, manually set priorities (freeware)
· http://www.3delite.hu/Process%20Priority%20Optimizer/index.html - shareware

Process Affinity Tools

· http://www.robpol86.com/Pages/imagecfg.php
· http://www.adsciengineering.com/StartAffinity/
· http://cpu.rightmark.org/products/rmclock.shtml

Memory Cache Management

· http://www.outertech.com/index.php?_charisma_page=product&id=2